
{*******************************************************}
{                                                       }
{       Borland Delphi Runtime Library                  }
{       Memo Web Browser                                }
{                                                       }
{       Copyright (C) 2001 Vino Rodrigues               }
{       vinorodrigues@yahoo.com                         }
{                                                       }
{       Version History:                                }
{       ----------------                                }
{                                                       }
{       1.1  30-Aug-01                                  }
{            First time I included "version history".   }
{                                                       }
{*******************************************************}

unit MWebBrw;

{$UNDEF DEBUG}
{.$DEFINE DEBUG}

{$IFDEF DEBUG}
  {$D+} // DEBUG
  {$C+}	// ASSERTIONS
  {$O-}	// OPTIMIZATION
  {$Q+}	// OVERFLOWCHECKS
  {$R+}	// RANGECHECKS
  {$Y+} // SYMBOL AND X-REF INFO
  {$L+} // LOCAL SYMBOL INFO
{$ELSE}
  {$D-} // DEBUG
  {$C-}	// ASSERTIONS
  {$Q-} // OVERFLOWCHECKS
  {$R-} // RANGECHECKS
  {$Y-} // SYMBOL AND X-REF INFO
  {$L-} // LOCAL SYMBOL INFO
{$ENDIF}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, OleServer, SHDocVw, MSHTML, ActiveX;

type
  TMemoWebBrowser = class(TWebBrowser)
  private
    FLines: TStrings;
    FOnDocumentComplete: TWebBrowserDocumentComplete;
    procedure Change(Sender: TObject);
    procedure DocumentComplete(Sender: TObject; const pDisp: IDispatch;
      var URL: OleVariant);
  protected
    procedure LoadDocument; virtual;
    procedure SetLines(Value: TStrings);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property Lines: TStrings read FLines write SetLines;
    {$WARNINGS OFF}
    property OnDocumentComplete: TWebBrowserDocumentComplete
      read FOnDocumentComplete write FOnDocumentComplete;
    {$WARNINGS ON}
  end;

implementation

{$IFDEF VER140}
uses
  Variants;
{$ENDIF}

resourcestring
  sLoadingPrompt = '<I><B>Loading . . .</B></I>';
  sEmptyPrompt = ''; //'<I>(Empty)</I>';

{ TMemoWebBrowser }

constructor TMemoWebBrowser.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FLines := TStringList.Create;
  inherited OnDocumentComplete := DocumentComplete;
end;

destructor TMemoWebBrowser.Destroy;
begin
  inherited OnDocumentComplete := nil;
  FLines.Free;
  inherited Destroy;
end;

procedure TMemoWebBrowser.Change(Sender: TObject);
begin
  Navigate('about:' + sLoadingPrompt);
end;

procedure TMemoWebBrowser.DocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
  LoadDocument;
  if Assigned(FOnDocumentComplete) then
    FOnDocumentComplete(Sender, pDisp, URL);
end;

procedure TMemoWebBrowser.LoadDocument;
var
  v: Variant;
  s: string;
  HTMLDocument: IHTMLDocument2;
begin
  HTMLDocument := Document as IHTMLDocument2;
  if Assigned(HTMLDocument) then
  begin
    v := VarArrayCreate([0, 0], varVariant);
    if FLines.Count = 0 then
      V[0] := sEmptyPrompt
    else
    begin
      s := FLines.GetText;
      V[0] := s;
    end;
    HTMLDocument.Write(PSafeArray(TVarData(v).VArray));
    HTMLDocument.Close;
  end;
end;

procedure TMemoWebBrowser.SetLines(Value: TStrings);
begin
  FLines.Assign(Value);
  Change(Self);
end;

end.
